﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace clent
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        Socket socketsend = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
        //连接服务器
        private void button1_Click(object sender, EventArgs e)
        {
            //创建连接用的socket


            //创建连接点
            IPAddress ip = IPAddress.Parse(txtip.Text);
            //创建要连接的网络点
            IPEndPoint point = new IPEndPoint(ip, Convert.ToInt32(txtpint.Text));

            //连接
            socketsend.Connect(point);
            ShowMsg("连接成功");

            //创建一个后台线层，用于接收服务器发来的数据
            Thread td = new Thread(jssend);
            td.IsBackground = true;
            td.Start();

        }

        /// <summary>
        /// 接收数据
        /// </summary>
        void jssend()
        {
            try
                {
            while (true)
            {
                
                    byte[] buf = new byte[1024 * 1024 * 2];
                    //实际接收到的字符数
                    int r = socketsend.Receive(buf);
                    if (r == 0)
                    {
                        break;
                    }
                //表示接收到的数据是文本
                    if (buf[0] == 0)
                    {
                        string str = Encoding.UTF8.GetString(buf, 1, r-1);
                        txtlog.AppendText(socketsend.RemoteEndPoint + ":" + str + "\r\n");
                    }
                    else if (buf[0] == 1)//表示接收到的数据是文件
                    {
                        SaveFileDialog sdg = new SaveFileDialog();
                        sdg.InitialDirectory = @"C:\Users\Administrator\Desktop";
                        sdg.Title = "选择保存位置";                       
                        sdg.ShowDialog(this);//此处一定要添加this

                        string filename = sdg.FileName;
                        using (FileStream fsw = new FileStream(filename, FileMode.OpenOrCreate, FileAccess.ReadWrite))
                        {
                            fsw.Write(buf, 1, r - 1);
                        }
                        MessageBox.Show("保存成功");

                    }
                    else if (buf[0] == 2)//表示接收到的数据是窗口抖动
                    {
                        int x = this.Location.X;
                        int y = this.Location.Y;
                        for (int i = 0; i < 100; i++)
                        {
                            this.Location = new Point(x - 10, y - 10);
                            this.Location = new Point(x, y);
                            
                        }
                    }
                   

                   
                }
            }
            catch{}
        }


        void ShowMsg(string str)
        {
            txtlog.AppendText(str + "\r\n");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            byte[] buf = Encoding.UTF8.GetBytes(txtsend.Text);
            socketsend.Send(buf);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Control.CheckForIllegalCrossThreadCalls = false;
        }
    }
}
